动态规划dp基础:求最大上升子序列和

题面:

Super Jumping! Jumping! Jumping!

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now. 
The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path. 
Your task is to output the maximum value according to the given chessmen list. 

Input

Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N 
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int. 
A test case starting with 0 terminates the input and this test case is not to be processed. 

Output

For each case, print the maximum according to rules, and one line one case. 

Sample Input

3 1 3 2
4 1 2 3 4
4 3 3 2 1
0

Sample Output

4
10
3

一开始以为是 求最长上升子序列和 ,后来才发现不是最长上升子序列。。

这个题目的意思是求最大的上升子序列和(不一定是最长的)

思路:从1开始到N-1使用 dp[i] 来记录在 i 位置能够取得的最大的上升子序列和,两层循环,外面一层是遍历所有的位置,内层循环是从0开始一直到 i-1 的位置,计算上升子序列的和。最后再遍历dp[0...N-1],找出最大的即可。

递推式:如果 a[j] < a[i] ,则: dp[ i ] = max(dp[ i ], dp[ j ] + a[ i ])

题解:

#include <iostream>
#include <algorithm>
#include <cstring>
#define maxn 1000
using namespace std;
int ans;
int a[maxn];
int dp[maxn+2];
int main(int argc, char const *argv[])
{
	int N;
	while(cin >> N){
		if (N == 0)
		{
			break;
		}
		memset(a, 0, sizeof(a));
		memset(dp, 0, sizeof(dp));
		ans = -1;
		for(int i=0; i<N; i++){
			cin >> a[i];
		}
		dp[0] = a[0];
		for(int i=1; i<N; i++){    //外层循环
			dp[i] = a[i];
			for(int j=0; j<i; j++){    //内层循环
				if (a[j]<a[i])
				{
					dp[i] = max(dp[i], dp[j] + a[i]);
				}
			}
		}
		for(int i=0; i<N; i++){
			ans = max(ans, dp[i]);
		}
		cout << ans << endl;
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/weixin_43826242/article/details/88556733